import{s as Ia,f as h,n as ja,o as Ga}from"../chunks/scheduler.37c15a92.js";import{S as Ra,i as Aa,g as l,s as n,r as w,m as g,H as Et,A as Ea,h as p,f as s,c as i,j as u,u as y,x as m,n as c,B as Ut,k as r,y as o,a,v as x,d as b,t as _,w as T}from"../chunks/index.7cb9c9b8.js";import{H as C,E as Ua}from"../chunks/EditOnGithub.858acfec.js";function qa(Cs){let f,Ft,qt,Dt,z,Nt,k,Bt,P,zs="Q-Learning is an <strong>off-policy value-based method that uses a TD approach to train its action-value function:</strong>",Vt,S,ks="<li><em>Off-policy</em>: we’ll talk about that at the end of this unit.</li> <li><em>Value-based method</em>: finds the optimal policy indirectly by training a value or action-value function that will tell us <strong>the value of each state or each state-action pair.</strong></li> <li><em>TD approach:</em> <strong>updates its action-value function at each step instead of at the end of the episode.</strong></li>",Jt,I,Ps="<strong>Q-Learning is the algorithm we use to train our Q-function</strong>, an <strong>action-value function</strong> that determines the value of being at a particular state and taking a specific action at that state.",Kt,j,Ss='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Q-function.jpg" alt="Q-function"/> <figcaption>Given a state and action, our Q Function outputs a state-action value (also called Q-value)</figcaption>',Xt,G,Is="The <strong>Q comes from “the Quality” (the value) of that action at that state.</strong>",Yt,R,js="Let’s recap the difference between value and reward:",Zt,A,Gs="<li>The <em>value of a state</em>, or a <em>state-action pair</em> is the expected cumulative reward our agent gets if it starts at this state (or state-action pair) and then acts accordingly to its policy.</li> <li>The <em>reward</em> is the <strong>feedback I get from the environment</strong> after performing an action at a state.</li>",te,E,Rs="Internally, our Q-function is encoded by <strong>a Q-table, a table where each cell corresponds to a state-action pair value.</strong> Think of this Q-table as <strong>the memory or cheat sheet of our Q-function.</strong>",ee,U,As="Let’s go through an example of a maze.",se,q,Es,ae,W,Us=`The Q-table is initialized. That’s why all values are = 0. This table <strong>contains, for each state and action, the corresponding state-action values.</strong>
For this simple example, the state is only defined by the position of the mouse. Therefore, we have 2*3 rows in our Q-table, one row for each possible position of the mouse. In more complex scenarios, the state could contain more information than the position of the actor.`,ne,O,qs,ie,F,Ws="Here we see that the <strong>state-action value of the initial state and going up is 0:</strong>",le,D,Os,pe,N,Fs="So: the Q-function uses a Q-table <strong>that has the value of each state-action pair.</strong> Given a state and action, <strong>our Q-function will search inside its Q-table to output the value.</strong>",me,B,Ds='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Q-function-2.jpg" alt="Q-function"/>',re,V,Ns="If we recap, <em>Q-Learning</em> <strong>is the RL algorithm that:</strong>",oe,J,Bs="<li>Trains a <em>Q-function</em> (an <strong>action-value function</strong>), which internally is a <strong>Q-table that contains all the state-action pair values.</strong></li> <li>Given a state and action, our Q-function <strong>will search its Q-table for the corresponding value.</strong></li> <li>When the training is done, <strong>we have an optimal Q-function, which means we have optimal Q-table.</strong></li> <li>And if we <strong>have an optimal Q-function</strong>, we <strong>have an optimal policy</strong> since we <strong>know the best action to take at each state.</strong></li>",ge,K,Vs,ce,X,Js="In the beginning, <strong>our Q-table is useless since it gives arbitrary values for each state-action pair</strong> (most of the time, we initialize the Q-table to 0). As the agent <strong>explores the environment and we update the Q-table, it will give us a better and better approximation</strong> to the optimal policy.",he,L,Ks='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Q-learning-1.jpg" alt="Q-learning"/> <figcaption>We see here that with the training, our Q-table is better since, thanks to it, we can know the value of each state-action pair.</figcaption>',ue,Y,Xs="Now that we understand what Q-Learning, Q-functions, and Q-tables are, <strong>let’s dive deeper into the Q-Learning algorithm</strong>.",fe,Z,ve,tt,Ys="This is the Q-Learning pseudocode; let’s study each part and <strong>see how it works with a simple example before implementing it.</strong> Don’t be intimidated by it, it’s simpler than it looks! We’ll go over each step.",de,et,Zs,we,st,ye,at,ta,xe,nt,ea="We need to initialize the Q-table for each state-action pair. <strong>Most of the time, we initialize with values of 0.</strong>",be,it,_e,lt,sa,Te,pt,aa="The epsilon-greedy strategy is a policy that handles the exploration/exploitation trade-off.",Le,mt,na="The idea is that, with an initial value of ɛ = 1.0:",Me,rt,ia="<li><em>With probability 1 — ɛ</em> : we do <strong>exploitation</strong> (aka our agent selects the action with the highest state-action pair value).</li> <li>With probability ɛ: <strong>we do exploration</strong> (trying random action).</li>",Qe,ot,la="At the beginning of the training, <strong>the probability of doing exploration will be huge since ɛ is very high, so most of the time, we’ll explore.</strong> But as the training goes on, and consequently our <strong>Q-table gets better and better in its estimations, we progressively reduce the epsilon value</strong> since we will need less and less exploration and more exploitation.",$e,gt,pa,He,ct,Ce,ht,ma,ze,ut,ke,ft,ra="Remember that in TD Learning, we update our policy or value function (depending on the RL method we choose) <strong>after one step of the interaction.</strong>",Pe,M,xs,vt,bs,Se,Ha='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex">R_{t+1}</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',Ie,_s,je,dt,oa,Ge,v,Ts,Re,Ca='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>Q</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mi>t</mi></msub><mo separator="true">,</mo><msub><mi>A</mi><mi>t</mi></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">Q(S_t, A_t)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">Q</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',Ae,jt,ga="update formula goes like this:",Ee,wt,ca,Ue,Q,Ls,qe,za='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>Q</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mi>t</mi></msub><mo separator="true">,</mo><msub><mi>A</mi><mi>t</mi></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">Q(S_t, A_t)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">Q</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',We,Oe,$,yt,Ms,Fe,ka='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mi>t</mi></msub><mo separator="true">,</mo><msub><mi>A</mi><mi>t</mi></msub><mo separator="true">,</mo><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub><mo separator="true">,</mo><msub><mi>S</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex">S_t, A_t, R_{t+1}, S_{t+1}</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',De,Qs,Gt,ha="To update our Q-value at a given state-action pair, we use the TD target.",Ne,xt,ua="How do we form the TD target?",Be,H,d,$s,Ve,Pa='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex">R_{t+1}</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',Je,Ke,Sa='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>A</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">A_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Xe,Hs,Rt,fa="To get the <strong>best state-action pair value</strong> for the next state, we use a greedy policy to select the next best action. Note that this is not an epsilon-greedy policy, this will always take the action with the highest state-action value.",Ye,bt,va="Then when the update of this Q-value is done, we start in a new state and select our action <strong>using a epsilon-greedy policy again.</strong>",Ze,_t,da="<strong>This is why we say that Q Learning is an off-policy algorithm.</strong>",ts,Tt,es,Lt,wa="The difference is subtle:",ss,Mt,ya="<li><em>Off-policy</em>: using <strong>a different policy for acting (inference) and updating (training).</strong></li>",as,Qt,xa="For instance, with Q-Learning, the epsilon-greedy policy (acting policy), is different from the greedy policy that is <strong>used to select the best next-state action value to update our Q-value (updating policy).</strong>",ns,$t,ba='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/off-on-1.jpg" alt="Off-on policy"/> <figcaption>Acting Policy</figcaption>',is,Ht,_a="Is different from the policy we use during the training part:",ls,Ct,Ta='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/off-on-2.jpg" alt="Off-on policy"/> <figcaption>Updating policy</figcaption>',ps,zt,La="<li><em>On-policy:</em> using the <strong>same policy for acting and updating.</strong></li>",ms,kt,Ma="For instance, with Sarsa, another value-based algorithm, <strong>the epsilon-greedy policy selects the next state-action pair, not a greedy policy.</strong>",rs,Pt,Qa='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/off-on-3.jpg" alt="Off-on policy"/> <figcaption>Sarsa</figcaption>',os,St,$a='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/off-on-4.jpg" alt="Off-on policy"/>',gs,It,cs,Wt,hs;return z=new C({props:{title:"Introducing Q-Learning",local:"q-learning",headingTag:"h1"}}),k=new C({props:{title:"What is Q-Learning?",local:"what-is-q-learning",headingTag:"h2"}}),Z=new C({props:{title:"The Q-Learning algorithm",local:"q-learning-algo",headingTag:"h2"}}),st=new C({props:{title:"Step 1: We initialize the Q-table",local:"step1",headingTag:"h3"}}),it=new C({props:{title:"Step 2: Choose an action using the epsilon-greedy strategy",local:"step2",headingTag:"h3"}}),ct=new C({props:{title:"Step 3: Perform action At, get reward Rt+1 and next state St+1",local:"step3",headingTag:"h3"}}),ut=new C({props:{title:"Step 4: Update Q(St, At)",local:"step4",headingTag:"h3"}}),Tt=new C({props:{title:"Off-policy vs On-policy",local:"off-vs-on",headingTag:"h2"}}),It=new Ua({props:{source:"https://github.com/huggingface/deep-rl-class/blob/main/units/en/unit2/q-learning.mdx"}}),{c(){f=l("meta"),Ft=n(),qt=l("p"),Dt=n(),w(z.$$.fragment),Nt=n(),w(k.$$.fragment),Bt=n(),P=l("p"),P.innerHTML=zs,Vt=n(),S=l("ul"),S.innerHTML=ks,Jt=n(),I=l("p"),I.innerHTML=Ps,Kt=n(),j=l("figure"),j.innerHTML=Ss,Xt=n(),G=l("p"),G.innerHTML=Is,Yt=n(),R=l("p"),R.textContent=js,Zt=n(),A=l("ul"),A.innerHTML=Gs,te=n(),E=l("p"),E.innerHTML=Rs,ee=n(),U=l("p"),U.textContent=As,se=n(),q=l("img"),ae=n(),W=l("p"),W.innerHTML=Us,ne=n(),O=l("img"),ie=n(),F=l("p"),F.innerHTML=Ws,le=n(),D=l("img"),pe=n(),N=l("p"),N.innerHTML=Fs,me=n(),B=l("figure"),B.innerHTML=Ds,re=n(),V=l("p"),V.innerHTML=Ns,oe=n(),J=l("ul"),J.innerHTML=Bs,ge=n(),K=l("img"),ce=n(),X=l("p"),X.innerHTML=Js,he=n(),L=l("figure"),L.innerHTML=Ks,ue=n(),Y=l("p"),Y.innerHTML=Xs,fe=n(),w(Z.$$.fragment),ve=n(),tt=l("p"),tt.innerHTML=Ys,de=n(),et=l("img"),we=n(),w(st.$$.fragment),ye=n(),at=l("img"),xe=n(),nt=l("p"),nt.innerHTML=ea,be=n(),w(it.$$.fragment),_e=n(),lt=l("img"),Te=n(),pt=l("p"),pt.textContent=aa,Le=n(),mt=l("p"),mt.textContent=na,Me=n(),rt=l("ul"),rt.innerHTML=ia,Qe=n(),ot=l("p"),ot.innerHTML=la,$e=n(),gt=l("img"),He=n(),w(ct.$$.fragment),Ce=n(),ht=l("img"),ze=n(),w(ut.$$.fragment),ke=n(),ft=l("p"),ft.innerHTML=ra,Pe=n(),M=l("p"),xs=g("To produce our TD target, "),vt=l("strong"),bs=g("we used the immediate reward"),Se=new Et(!1),Ie=g(" plus the discounted value of the next state"),_s=g(", computed by finding the action that maximizes the current Q-function at the next state. (We call that bootstrap)."),je=n(),dt=l("img"),Ge=n(),v=l("p"),Ts=g("Therefore, our"),Re=new Et(!1),Ae=g(" "),jt=l("strong"),jt.textContent=ga,Ee=n(),wt=l("img"),Ue=n(),Q=l("p"),Ls=g("This means that to update our"),qe=new Et(!1),We=g(":"),Oe=n(),$=l("ul"),yt=l("li"),Ms=g("We need"),Fe=new Et(!1),De=g("."),Qs=n(),Gt=l("li"),Gt.textContent=ha,Ne=n(),xt=l("p"),xt.textContent=ua,Be=n(),H=l("ol"),d=l("li"),$s=g("We obtain the reward"),Ve=new Et(!1),Je=g(" after taking the action"),Ke=new Et(!1),Xe=g("."),Hs=n(),Rt=l("li"),Rt.innerHTML=fa,Ye=n(),bt=l("p"),bt.innerHTML=va,Ze=n(),_t=l("p"),_t.innerHTML=da,ts=n(),w(Tt.$$.fragment),es=n(),Lt=l("p"),Lt.textContent=wa,ss=n(),Mt=l("ul"),Mt.innerHTML=ya,as=n(),Qt=l("p"),Qt.innerHTML=xa,ns=n(),$t=l("figure"),$t.innerHTML=ba,is=n(),Ht=l("p"),Ht.textContent=_a,ls=n(),Ct=l("figure"),Ct.innerHTML=Ta,ps=n(),zt=l("ul"),zt.innerHTML=La,ms=n(),kt=l("p"),kt.innerHTML=Ma,rs=n(),Pt=l("figure"),Pt.innerHTML=Qa,os=n(),St=l("figure"),St.innerHTML=$a,gs=n(),w(It.$$.fragment),cs=n(),Wt=l("p"),this.h()},l(t){const e=Ea("svelte-u9bgzb",document.head);f=p(e,"META",{name:!0,content:!0}),e.forEach(s),Ft=i(t),qt=p(t,"P",{}),u(qt).forEach(s),Dt=i(t),y(z.$$.fragment,t),Nt=i(t),y(k.$$.fragment,t),Bt=i(t),P=p(t,"P",{"data-svelte-h":!0}),m(P)!=="svelte-vs38b5"&&(P.innerHTML=zs),Vt=i(t),S=p(t,"UL",{"data-svelte-h":!0}),m(S)!=="svelte-10wsnaz"&&(S.innerHTML=ks),Jt=i(t),I=p(t,"P",{"data-svelte-h":!0}),m(I)!=="svelte-1bdys1r"&&(I.innerHTML=Ps),Kt=i(t),j=p(t,"FIGURE",{"data-svelte-h":!0}),m(j)!=="svelte-5lmfx0"&&(j.innerHTML=Ss),Xt=i(t),G=p(t,"P",{"data-svelte-h":!0}),m(G)!=="svelte-crnsdp"&&(G.innerHTML=Is),Yt=i(t),R=p(t,"P",{"data-svelte-h":!0}),m(R)!=="svelte-1ubk9oh"&&(R.textContent=js),Zt=i(t),A=p(t,"UL",{"data-svelte-h":!0}),m(A)!=="svelte-1nda8m2"&&(A.innerHTML=Gs),te=i(t),E=p(t,"P",{"data-svelte-h":!0}),m(E)!=="svelte-gdw4y7"&&(E.innerHTML=Rs),ee=i(t),U=p(t,"P",{"data-svelte-h":!0}),m(U)!=="svelte-1cli1ai"&&(U.textContent=As),se=i(t),q=p(t,"IMG",{src:!0,alt:!0}),ae=i(t),W=p(t,"P",{"data-svelte-h":!0}),m(W)!=="svelte-uc057n"&&(W.innerHTML=Us),ne=i(t),O=p(t,"IMG",{src:!0,alt:!0}),ie=i(t),F=p(t,"P",{"data-svelte-h":!0}),m(F)!=="svelte-1v5c7t0"&&(F.innerHTML=Ws),le=i(t),D=p(t,"IMG",{src:!0,alt:!0}),pe=i(t),N=p(t,"P",{"data-svelte-h":!0}),m(N)!=="svelte-1ptm42n"&&(N.innerHTML=Fs),me=i(t),B=p(t,"FIGURE",{"data-svelte-h":!0}),m(B)!=="svelte-1wlsy73"&&(B.innerHTML=Ds),re=i(t),V=p(t,"P",{"data-svelte-h":!0}),m(V)!=="svelte-18kluj9"&&(V.innerHTML=Ns),oe=i(t),J=p(t,"UL",{"data-svelte-h":!0}),m(J)!=="svelte-rhztxe"&&(J.innerHTML=Bs),ge=i(t),K=p(t,"IMG",{src:!0,alt:!0}),ce=i(t),X=p(t,"P",{"data-svelte-h":!0}),m(X)!=="svelte-upi7hl"&&(X.innerHTML=Js),he=i(t),L=p(t,"FIGURE",{class:!0,"data-svelte-h":!0}),m(L)!=="svelte-qceb0"&&(L.innerHTML=Ks),ue=i(t),Y=p(t,"P",{"data-svelte-h":!0}),m(Y)!=="svelte-1jxrnuj"&&(Y.innerHTML=Xs),fe=i(t),y(Z.$$.fragment,t),ve=i(t),tt=p(t,"P",{"data-svelte-h":!0}),m(tt)!=="svelte-1fdmnfq"&&(tt.innerHTML=Ys),de=i(t),et=p(t,"IMG",{src:!0,alt:!0}),we=i(t),y(st.$$.fragment,t),ye=i(t),at=p(t,"IMG",{src:!0,alt:!0}),xe=i(t),nt=p(t,"P",{"data-svelte-h":!0}),m(nt)!=="svelte-hvlw74"&&(nt.innerHTML=ea),be=i(t),y(it.$$.fragment,t),_e=i(t),lt=p(t,"IMG",{src:!0,alt:!0}),Te=i(t),pt=p(t,"P",{"data-svelte-h":!0}),m(pt)!=="svelte-1rsicc3"&&(pt.textContent=aa),Le=i(t),mt=p(t,"P",{"data-svelte-h":!0}),m(mt)!=="svelte-1p8nnff"&&(mt.textContent=na),Me=i(t),rt=p(t,"UL",{"data-svelte-h":!0}),m(rt)!=="svelte-1qbe9yz"&&(rt.innerHTML=ia),Qe=i(t),ot=p(t,"P",{"data-svelte-h":!0}),m(ot)!=="svelte-vlbioi"&&(ot.innerHTML=la),$e=i(t),gt=p(t,"IMG",{src:!0,alt:!0}),He=i(t),y(ct.$$.fragment,t),Ce=i(t),ht=p(t,"IMG",{src:!0,alt:!0}),ze=i(t),y(ut.$$.fragment,t),ke=i(t),ft=p(t,"P",{"data-svelte-h":!0}),m(ft)!=="svelte-19iw7lu"&&(ft.innerHTML=ra),Pe=i(t),M=p(t,"P",{});var us=u(M);xs=c(us,"To produce our TD target, "),vt=p(us,"STRONG",{});var fs=u(vt);bs=c(fs,"we used the immediate reward"),Se=Ut(fs,!1),Ie=c(fs," plus the discounted value of the next state"),fs.forEach(s),_s=c(us,", computed by finding the action that maximizes the current Q-function at the next state. (We call that bootstrap)."),us.forEach(s),je=i(t),dt=p(t,"IMG",{src:!0,alt:!0}),Ge=i(t),v=p(t,"P",{});var Ot=u(v);Ts=c(Ot,"Therefore, our"),Re=Ut(Ot,!1),Ae=c(Ot," "),jt=p(Ot,"STRONG",{"data-svelte-h":!0}),m(jt)!=="svelte-12kejy4"&&(jt.textContent=ga),Ot.forEach(s),Ee=i(t),wt=p(t,"IMG",{src:!0,alt:!0}),Ue=i(t),Q=p(t,"P",{});var vs=u(Q);Ls=c(vs,"This means that to update our"),qe=Ut(vs,!1),We=c(vs,":"),vs.forEach(s),Oe=i(t),$=p(t,"UL",{});var ds=u($);yt=p(ds,"LI",{});var ws=u(yt);Ms=c(ws,"We need"),Fe=Ut(ws,!1),De=c(ws,"."),ws.forEach(s),Qs=i(ds),Gt=p(ds,"LI",{"data-svelte-h":!0}),m(Gt)!=="svelte-1ihnbvx"&&(Gt.textContent=ha),ds.forEach(s),Ne=i(t),xt=p(t,"P",{"data-svelte-h":!0}),m(xt)!=="svelte-1dxw0aw"&&(xt.textContent=ua),Be=i(t),H=p(t,"OL",{});var ys=u(H);d=p(ys,"LI",{});var At=u(d);$s=c(At,"We obtain the reward"),Ve=Ut(At,!1),Je=c(At," after taking the action"),Ke=Ut(At,!1),Xe=c(At,"."),At.forEach(s),Hs=i(ys),Rt=p(ys,"LI",{"data-svelte-h":!0}),m(Rt)!=="svelte-ncl2c6"&&(Rt.innerHTML=fa),ys.forEach(s),Ye=i(t),bt=p(t,"P",{"data-svelte-h":!0}),m(bt)!=="svelte-yt04ce"&&(bt.innerHTML=va),Ze=i(t),_t=p(t,"P",{"data-svelte-h":!0}),m(_t)!=="svelte-rw0dnq"&&(_t.innerHTML=da),ts=i(t),y(Tt.$$.fragment,t),es=i(t),Lt=p(t,"P",{"data-svelte-h":!0}),m(Lt)!=="svelte-1660nrr"&&(Lt.textContent=wa),ss=i(t),Mt=p(t,"UL",{"data-svelte-h":!0}),m(Mt)!=="svelte-jbg8q"&&(Mt.innerHTML=ya),as=i(t),Qt=p(t,"P",{"data-svelte-h":!0}),m(Qt)!=="svelte-5r7jq0"&&(Qt.innerHTML=xa),ns=i(t),$t=p(t,"FIGURE",{"data-svelte-h":!0}),m($t)!=="svelte-2uzk1v"&&($t.innerHTML=ba),is=i(t),Ht=p(t,"P",{"data-svelte-h":!0}),m(Ht)!=="svelte-1xs5vi8"&&(Ht.textContent=_a),ls=i(t),Ct=p(t,"FIGURE",{"data-svelte-h":!0}),m(Ct)!=="svelte-2rk9mg"&&(Ct.innerHTML=Ta),ps=i(t),zt=p(t,"UL",{"data-svelte-h":!0}),m(zt)!=="svelte-19dbnnc"&&(zt.innerHTML=La),ms=i(t),kt=p(t,"P",{"data-svelte-h":!0}),m(kt)!=="svelte-3lwzbr"&&(kt.innerHTML=Ma),rs=i(t),Pt=p(t,"FIGURE",{"data-svelte-h":!0}),m(Pt)!=="svelte-1qn38id"&&(Pt.innerHTML=Qa),os=i(t),St=p(t,"FIGURE",{"data-svelte-h":!0}),m(St)!=="svelte-1e5hwrp"&&(St.innerHTML=$a),gs=i(t),y(It.$$.fragment,t),cs=i(t),Wt=p(t,"P",{}),u(Wt).forEach(s),this.h()},h(){r(f,"name","hf:doc:metadata"),r(f,"content",Wa),h(q.src,Es="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Maze-1.jpg")||r(q,"src",Es),r(q,"alt","Maze example"),h(O.src,qs="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Maze-2.jpg")||r(O,"src",qs),r(O,"alt","Maze example"),h(D.src,Os="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Maze-3.jpg")||r(D,"src",Os),r(D,"alt","Maze example"),h(K.src,Vs="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/link-value-policy.jpg")||r(K,"src",Vs),r(K,"alt","Link value policy"),r(L,"class","image table text-center m-0 w-full"),h(et.src,Zs="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Q-learning-2.jpg")||r(et,"src",Zs),r(et,"alt","Q-learning"),h(at.src,ta="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Q-learning-3.jpg")||r(at,"src",ta),r(at,"alt","Q-learning"),h(lt.src,sa="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Q-learning-4.jpg")||r(lt,"src",sa),r(lt,"alt","Q-learning"),h(gt.src,pa="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Q-learning-5.jpg")||r(gt,"src",pa),r(gt,"alt","Q-learning"),h(ht.src,ma="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Q-learning-6.jpg")||r(ht,"src",ma),r(ht,"alt","Q-learning"),Se.a=Ie,h(dt.src,oa="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Q-learning-7.jpg")||r(dt,"src",oa),r(dt,"alt","Q-learning"),Re.a=Ae,h(wt.src,ca="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Q-learning-8.jpg")||r(wt,"src",ca),r(wt,"alt","Q-learning"),qe.a=We,Fe.a=De,Ve.a=Je,Ke.a=Xe},m(t,e){o(document.head,f),a(t,Ft,e),a(t,qt,e),a(t,Dt,e),x(z,t,e),a(t,Nt,e),x(k,t,e),a(t,Bt,e),a(t,P,e),a(t,Vt,e),a(t,S,e),a(t,Jt,e),a(t,I,e),a(t,Kt,e),a(t,j,e),a(t,Xt,e),a(t,G,e),a(t,Yt,e),a(t,R,e),a(t,Zt,e),a(t,A,e),a(t,te,e),a(t,E,e),a(t,ee,e),a(t,U,e),a(t,se,e),a(t,q,e),a(t,ae,e),a(t,W,e),a(t,ne,e),a(t,O,e),a(t,ie,e),a(t,F,e),a(t,le,e),a(t,D,e),a(t,pe,e),a(t,N,e),a(t,me,e),a(t,B,e),a(t,re,e),a(t,V,e),a(t,oe,e),a(t,J,e),a(t,ge,e),a(t,K,e),a(t,ce,e),a(t,X,e),a(t,he,e),a(t,L,e),a(t,ue,e),a(t,Y,e),a(t,fe,e),x(Z,t,e),a(t,ve,e),a(t,tt,e),a(t,de,e),a(t,et,e),a(t,we,e),x(st,t,e),a(t,ye,e),a(t,at,e),a(t,xe,e),a(t,nt,e),a(t,be,e),x(it,t,e),a(t,_e,e),a(t,lt,e),a(t,Te,e),a(t,pt,e),a(t,Le,e),a(t,mt,e),a(t,Me,e),a(t,rt,e),a(t,Qe,e),a(t,ot,e),a(t,$e,e),a(t,gt,e),a(t,He,e),x(ct,t,e),a(t,Ce,e),a(t,ht,e),a(t,ze,e),x(ut,t,e),a(t,ke,e),a(t,ft,e),a(t,Pe,e),a(t,M,e),o(M,xs),o(M,vt),o(vt,bs),Se.m(Ha,vt),o(vt,Ie),o(M,_s),a(t,je,e),a(t,dt,e),a(t,Ge,e),a(t,v,e),o(v,Ts),Re.m(Ca,v),o(v,Ae),o(v,jt),a(t,Ee,e),a(t,wt,e),a(t,Ue,e),a(t,Q,e),o(Q,Ls),qe.m(za,Q),o(Q,We),a(t,Oe,e),a(t,$,e),o($,yt),o(yt,Ms),Fe.m(ka,yt),o(yt,De),o($,Qs),o($,Gt),a(t,Ne,e),a(t,xt,e),a(t,Be,e),a(t,H,e),o(H,d),o(d,$s),Ve.m(Pa,d),o(d,Je),Ke.m(Sa,d),o(d,Xe),o(H,Hs),o(H,Rt),a(t,Ye,e),a(t,bt,e),a(t,Ze,e),a(t,_t,e),a(t,ts,e),x(Tt,t,e),a(t,es,e),a(t,Lt,e),a(t,ss,e),a(t,Mt,e),a(t,as,e),a(t,Qt,e),a(t,ns,e),a(t,$t,e),a(t,is,e),a(t,Ht,e),a(t,ls,e),a(t,Ct,e),a(t,ps,e),a(t,zt,e),a(t,ms,e),a(t,kt,e),a(t,rs,e),a(t,Pt,e),a(t,os,e),a(t,St,e),a(t,gs,e),x(It,t,e),a(t,cs,e),a(t,Wt,e),hs=!0},p:ja,i(t){hs||(b(z.$$.fragment,t),b(k.$$.fragment,t),b(Z.$$.fragment,t),b(st.$$.fragment,t),b(it.$$.fragment,t),b(ct.$$.fragment,t),b(ut.$$.fragment,t),b(Tt.$$.fragment,t),b(It.$$.fragment,t),hs=!0)},o(t){_(z.$$.fragment,t),_(k.$$.fragment,t),_(Z.$$.fragment,t),_(st.$$.fragment,t),_(it.$$.fragment,t),_(ct.$$.fragment,t),_(ut.$$.fragment,t),_(Tt.$$.fragment,t),_(It.$$.fragment,t),hs=!1},d(t){t&&(s(Ft),s(qt),s(Dt),s(Nt),s(Bt),s(P),s(Vt),s(S),s(Jt),s(I),s(Kt),s(j),s(Xt),s(G),s(Yt),s(R),s(Zt),s(A),s(te),s(E),s(ee),s(U),s(se),s(q),s(ae),s(W),s(ne),s(O),s(ie),s(F),s(le),s(D),s(pe),s(N),s(me),s(B),s(re),s(V),s(oe),s(J),s(ge),s(K),s(ce),s(X),s(he),s(L),s(ue),s(Y),s(fe),s(ve),s(tt),s(de),s(et),s(we),s(ye),s(at),s(xe),s(nt),s(be),s(_e),s(lt),s(Te),s(pt),s(Le),s(mt),s(Me),s(rt),s(Qe),s(ot),s($e),s(gt),s(He),s(Ce),s(ht),s(ze),s(ke),s(ft),s(Pe),s(M),s(je),s(dt),s(Ge),s(v),s(Ee),s(wt),s(Ue),s(Q),s(Oe),s($),s(Ne),s(xt),s(Be),s(H),s(Ye),s(bt),s(Ze),s(_t),s(ts),s(es),s(Lt),s(ss),s(Mt),s(as),s(Qt),s(ns),s($t),s(is),s(Ht),s(ls),s(Ct),s(ps),s(zt),s(ms),s(kt),s(rs),s(Pt),s(os),s(St),s(gs),s(cs),s(Wt)),s(f),T(z,t),T(k,t),T(Z,t),T(st,t),T(it,t),T(ct,t),T(ut,t),T(Tt,t),T(It,t)}}}const Wa='{"title":"Introducing Q-Learning","local":"q-learning","sections":[{"title":"What is Q-Learning?","local":"what-is-q-learning","sections":[],"depth":2},{"title":"The Q-Learning algorithm","local":"q-learning-algo","sections":[{"title":"Step 1: We initialize the Q-table","local":"step1","sections":[],"depth":3},{"title":"Step 2: Choose an action using the epsilon-greedy strategy","local":"step2","sections":[],"depth":3},{"title":"Step 3: Perform action At, get reward Rt+1 and next state St+1","local":"step3","sections":[],"depth":3},{"title":"Step 4: Update Q(St, At)","local":"step4","sections":[],"depth":3}],"depth":2},{"title":"Off-policy vs On-policy","local":"off-vs-on","sections":[],"depth":2}],"depth":1}';function Oa(Cs){return Ga(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ba extends Ra{constructor(f){super(),Aa(this,f,Oa,qa,Ia,{})}}export{Ba as component};
